package boltdb

import (
	"testing"

	"corelab.mkcl.org/MKCLOS/coredevelopmentplatform/corepkgv2/errormdl"
	"github.com/stretchr/testify/assert"
)

const (
	bucketName  = "test"
	dbPathWrong = "C:/test/test.db"
)

func TestInitDB(t *testing.T) {
	_, err := InitDB("C:/test.db", bucketName)
	assert.NoError(t, err, "This should not return error")
}
func TestInitDBOpenDbError(t *testing.T) {
	errormdl.IsTestingNegetiveCaseOn = true
	_, err := InitDB(dbPathWrong, bucketName)
	errormdl.IsTestingNegetiveCaseOn = false
	assert.Error(t, err, "This should return error")
}
func TestInitDBBktError(t *testing.T) {
	errormdl.IsTestingNegetiveCaseOn1 = true
	_, err := InitDB("C:/test1.db", bucketName)
	errormdl.IsTestingNegetiveCaseOn1 = false
	assert.Error(t, err, "This should return error")
}
func TestAddKey(t *testing.T) {
	dbIntsance, _ := InitDB("C:/test2.db", bucketName)
	err2 := AddKey(dbIntsance, bucketName, "testKey", "testValue")
	assert.NoError(t, err2, "This should not return error")
}

func TestRemoveKey(t *testing.T) {
	dbIntsance, _ := InitDB("C:/test3.db", bucketName)
	AddKey(dbIntsance, bucketName, "testKey", "testValue")
	err3 := RemoveKey(dbIntsance, bucketName, "testKey")
	assert.NoError(t, err3, "This should not return error")
}
func TestGetKey(t *testing.T) {
	dbIntsance, _ := InitDB("C:/test4.db", bucketName)
	AddKey(dbIntsance, bucketName, "testKey", "testValue")
	_, err := GetKey(dbIntsance, bucketName, "testKey")
	assert.NoError(t, err, "This should not return error")
}

func TestGetKeyBktErr(t *testing.T) {
	dbIntsance, _ := InitDB("C:/test5.db", bucketName)
	_, err := GetKey(dbIntsance, "mdasda", "testKey")
	assert.Error(t, err, "This should return error")
}

type BucketData struct {
	Name string `json:"name"`
}

func TestAddRecord(t *testing.T) {
	dbIntsance, _ := InitDB("C:/test6.db", bucketName)
	bucketData := BucketData{}
	bucketData.Name = "test"
	err := AddRecord(dbIntsance, "myname", bucketData, bucketName)
	assert.NoError(t, err, "This should not return error")
}

func TestAddRecordError(t *testing.T) {
	dbIntsance, _ := InitDB("C:/test7.db", bucketName)
	bucketData := BucketData{}
	bucketData.Name = "test"
	errormdl.IsTestingNegetiveCaseOn = true
	err := AddRecord(dbIntsance, "myname", bucketData, bucketName)
	errormdl.IsTestingNegetiveCaseOn = false
	assert.Error(t, err, "This should return error")
}
func TestAddRecordError1(t *testing.T) {
	dbIntsance, _ := InitDB("C:/test8.db", bucketName)
	bucketData := BucketData{}
	bucketData.Name = "test"
	errormdl.IsTestingNegetiveCaseOn1 = true
	err := AddRecord(dbIntsance, "myname", bucketData, bucketName)
	errormdl.IsTestingNegetiveCaseOn1 = false
	assert.Error(t, err, "This should return error")
}
func TestGetRecord(t *testing.T) {
	dbIntsance, _ := InitDB("C:/test9.db", bucketName)
	bucketData := BucketData{}
	bucketData.Name = "test"
	AddRecord(dbIntsance, "myname", bucketData, bucketName)
	_, err2 := GetRecord(dbIntsance, bucketName)
	assert.NoError(t, err2, "This should not return error")
}
func TestGetRecordError(t *testing.T) {
	dbIntsance, _ := InitDB("C:/test10.db", bucketName)
	errormdl.IsTestingNegetiveCaseOn = true
	_, err2 := GetRecord(dbIntsance, bucketName)
	errormdl.IsTestingNegetiveCaseOn = false
	assert.Error(t, err2, "This should return error")
}

func TestGetRecordError1(t *testing.T) {
	dbIntsance, _ := InitDB("C:/test11.db", bucketName)
	errormdl.IsTestingNegetiveCaseOn1 = true
	_, err2 := GetRecord(dbIntsance, bucketName)
	errormdl.IsTestingNegetiveCaseOn1 = false
	assert.Error(t, err2, "This should return error")
}
